﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.34014
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

// 
// This source code was auto-generated by Microsoft.VSDesigner, Version 4.0.30319.34014.
// 
#pragma warning disable 1591

namespace WebServices.ApprovalRequestsServiceWeb {
    using System;
    using System.Web.Services;
    using System.Diagnostics;
    using System.Web.Services.Protocols;
    using System.Xml.Serialization;
    using System.ComponentModel;
    
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Web.Services.WebServiceBindingAttribute(Name="ApprovalRequestsServiceSoap", Namespace="ApprovalRequestsService")]
    public partial class ApprovalRequestsService : System.Web.Services.Protocols.SoapHttpClientProtocol {
        
        private MsgHeader msgHeaderValueField;
        
        private System.Threading.SendOrPostCallback UpdateRequestOperationCompleted;
        
        private System.Threading.SendOrPostCallback GetApprovalRequestOperationCompleted;
        
        private System.Threading.SendOrPostCallback GetApprovalRequestListOperationCompleted;
        
        private System.Threading.SendOrPostCallback GetOpenApprovalRequestListOperationCompleted;
        
        private System.Threading.SendOrPostCallback GetAllApprovalRequestsListOperationCompleted;
        
        private bool useDefaultCredentialsSetExplicitly;
        
        /// <remarks/>
        public ApprovalRequestsService() {
            this.Url = global::WebServices.Properties.Settings.Default.WebServices_DraftsServiceWeb_DraftsService;
            if ((this.IsLocalFileSystemWebService(this.Url) == true)) {
                this.UseDefaultCredentials = true;
                this.useDefaultCredentialsSetExplicitly = false;
            }
            else {
                this.useDefaultCredentialsSetExplicitly = true;
            }
        }
        
        public MsgHeader MsgHeaderValue {
            get {
                return this.msgHeaderValueField;
            }
            set {
                this.msgHeaderValueField = value;
            }
        }
        
        public new string Url {
            get {
                return base.Url;
            }
            set {
                if ((((this.IsLocalFileSystemWebService(base.Url) == true) 
                            && (this.useDefaultCredentialsSetExplicitly == false)) 
                            && (this.IsLocalFileSystemWebService(value) == false))) {
                    base.UseDefaultCredentials = false;
                }
                base.Url = value;
            }
        }
        
        public new bool UseDefaultCredentials {
            get {
                return base.UseDefaultCredentials;
            }
            set {
                base.UseDefaultCredentials = value;
                this.useDefaultCredentialsSetExplicitly = true;
            }
        }
        
        /// <remarks/>
        public event UpdateRequestCompletedEventHandler UpdateRequestCompleted;
        
        /// <remarks/>
        public event GetApprovalRequestCompletedEventHandler GetApprovalRequestCompleted;
        
        /// <remarks/>
        public event GetApprovalRequestListCompletedEventHandler GetApprovalRequestListCompleted;
        
        /// <remarks/>
        public event GetOpenApprovalRequestListCompletedEventHandler GetOpenApprovalRequestListCompleted;
        
        /// <remarks/>
        public event GetAllApprovalRequestsListCompletedEventHandler GetAllApprovalRequestsListCompleted;
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("ApprovalRequestsService/UpdateRequest", RequestNamespace="ApprovalRequestsService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public void UpdateRequest([System.Xml.Serialization.XmlElementAttribute(Namespace="http://www.sap.com/SBO/DIS")] ApprovalRequest ApprovalRequest) {
            this.Invoke("UpdateRequest", new object[] {
                        ApprovalRequest});
        }
        
        /// <remarks/>
        public void UpdateRequestAsync(ApprovalRequest ApprovalRequest) {
            this.UpdateRequestAsync(ApprovalRequest, null);
        }
        
        /// <remarks/>
        public void UpdateRequestAsync(ApprovalRequest ApprovalRequest, object userState) {
            if ((this.UpdateRequestOperationCompleted == null)) {
                this.UpdateRequestOperationCompleted = new System.Threading.SendOrPostCallback(this.OnUpdateRequestOperationCompleted);
            }
            this.InvokeAsync("UpdateRequest", new object[] {
                        ApprovalRequest}, this.UpdateRequestOperationCompleted, userState);
        }
        
        private void OnUpdateRequestOperationCompleted(object arg) {
            if ((this.UpdateRequestCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.UpdateRequestCompleted(this, new System.ComponentModel.AsyncCompletedEventArgs(invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("ApprovalRequestsService/GetApprovalRequest", RequestNamespace="ApprovalRequestsService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlElementAttribute("ApprovalRequest")]
        public ApprovalRequest GetApprovalRequest([System.Xml.Serialization.XmlElementAttribute(Namespace="http://www.sap.com/SBO/DIS")] ApprovalRequestParams ApprovalRequestParams) {
            object[] results = this.Invoke("GetApprovalRequest", new object[] {
                        ApprovalRequestParams});
            return ((ApprovalRequest)(results[0]));
        }
        
        /// <remarks/>
        public void GetApprovalRequestAsync(ApprovalRequestParams ApprovalRequestParams) {
            this.GetApprovalRequestAsync(ApprovalRequestParams, null);
        }
        
        /// <remarks/>
        public void GetApprovalRequestAsync(ApprovalRequestParams ApprovalRequestParams, object userState) {
            if ((this.GetApprovalRequestOperationCompleted == null)) {
                this.GetApprovalRequestOperationCompleted = new System.Threading.SendOrPostCallback(this.OnGetApprovalRequestOperationCompleted);
            }
            this.InvokeAsync("GetApprovalRequest", new object[] {
                        ApprovalRequestParams}, this.GetApprovalRequestOperationCompleted, userState);
        }
        
        private void OnGetApprovalRequestOperationCompleted(object arg) {
            if ((this.GetApprovalRequestCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.GetApprovalRequestCompleted(this, new GetApprovalRequestCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("ApprovalRequestsService/GetApprovalRequestList", RequestNamespace="ApprovalRequestsService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlArrayAttribute("ApprovalRequestsParams")]
        [return: System.Xml.Serialization.XmlArrayItemAttribute("ApprovalRequestParams", IsNullable=false)]
        public ApprovalRequestsParamsApprovalRequestParams[] GetApprovalRequestList() {
            object[] results = this.Invoke("GetApprovalRequestList", new object[0]);
            return ((ApprovalRequestsParamsApprovalRequestParams[])(results[0]));
        }
        
        /// <remarks/>
        public void GetApprovalRequestListAsync() {
            this.GetApprovalRequestListAsync(null);
        }
        
        /// <remarks/>
        public void GetApprovalRequestListAsync(object userState) {
            if ((this.GetApprovalRequestListOperationCompleted == null)) {
                this.GetApprovalRequestListOperationCompleted = new System.Threading.SendOrPostCallback(this.OnGetApprovalRequestListOperationCompleted);
            }
            this.InvokeAsync("GetApprovalRequestList", new object[0], this.GetApprovalRequestListOperationCompleted, userState);
        }
        
        private void OnGetApprovalRequestListOperationCompleted(object arg) {
            if ((this.GetApprovalRequestListCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.GetApprovalRequestListCompleted(this, new GetApprovalRequestListCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("ApprovalRequestsService/GetOpenApprovalRequestList", RequestNamespace="ApprovalRequestsService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlArrayAttribute("ApprovalRequestsParams")]
        [return: System.Xml.Serialization.XmlArrayItemAttribute("ApprovalRequestParams", IsNullable=false)]
        public ApprovalRequestsParamsApprovalRequestParams[] GetOpenApprovalRequestList() {
            object[] results = this.Invoke("GetOpenApprovalRequestList", new object[0]);
            return ((ApprovalRequestsParamsApprovalRequestParams[])(results[0]));
        }
        
        /// <remarks/>
        public void GetOpenApprovalRequestListAsync() {
            this.GetOpenApprovalRequestListAsync(null);
        }
        
        /// <remarks/>
        public void GetOpenApprovalRequestListAsync(object userState) {
            if ((this.GetOpenApprovalRequestListOperationCompleted == null)) {
                this.GetOpenApprovalRequestListOperationCompleted = new System.Threading.SendOrPostCallback(this.OnGetOpenApprovalRequestListOperationCompleted);
            }
            this.InvokeAsync("GetOpenApprovalRequestList", new object[0], this.GetOpenApprovalRequestListOperationCompleted, userState);
        }
        
        private void OnGetOpenApprovalRequestListOperationCompleted(object arg) {
            if ((this.GetOpenApprovalRequestListCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.GetOpenApprovalRequestListCompleted(this, new GetOpenApprovalRequestListCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("ApprovalRequestsService/GetAllApprovalRequestsList", RequestNamespace="ApprovalRequestsService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlArrayAttribute("ApprovalRequestsParams")]
        [return: System.Xml.Serialization.XmlArrayItemAttribute("ApprovalRequestParams", IsNullable=false)]
        public ApprovalRequestsParamsApprovalRequestParams[] GetAllApprovalRequestsList() {
            object[] results = this.Invoke("GetAllApprovalRequestsList", new object[0]);
            return ((ApprovalRequestsParamsApprovalRequestParams[])(results[0]));
        }
        
        /// <remarks/>
        public void GetAllApprovalRequestsListAsync() {
            this.GetAllApprovalRequestsListAsync(null);
        }
        
        /// <remarks/>
        public void GetAllApprovalRequestsListAsync(object userState) {
            if ((this.GetAllApprovalRequestsListOperationCompleted == null)) {
                this.GetAllApprovalRequestsListOperationCompleted = new System.Threading.SendOrPostCallback(this.OnGetAllApprovalRequestsListOperationCompleted);
            }
            this.InvokeAsync("GetAllApprovalRequestsList", new object[0], this.GetAllApprovalRequestsListOperationCompleted, userState);
        }
        
        private void OnGetAllApprovalRequestsListOperationCompleted(object arg) {
            if ((this.GetAllApprovalRequestsListCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.GetAllApprovalRequestsListCompleted(this, new GetAllApprovalRequestsListCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        public new void CancelAsync(object userState) {
            base.CancelAsync(userState);
        }
        
        private bool IsLocalFileSystemWebService(string url) {
            if (((url == null) 
                        || (url == string.Empty))) {
                return false;
            }
            System.Uri wsUri = new System.Uri(url);
            if (((wsUri.Port >= 1024) 
                        && (string.Compare(wsUri.Host, "localHost", System.StringComparison.OrdinalIgnoreCase) == 0))) {
                return true;
            }
            return false;
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    [System.Xml.Serialization.XmlRootAttribute(Namespace="http://www.sap.com/SBO/DIS", IsNullable=false)]
    public partial class MsgHeader : System.Web.Services.Protocols.SoapHeader {
        
        private string sessionIDField;
        
        private MsgHeaderServiceName serviceNameField;
        
        private bool serviceNameFieldSpecified;
        
        /// <remarks/>
        public string SessionID {
            get {
                return this.sessionIDField;
            }
            set {
                this.sessionIDField = value;
            }
        }
        
        /// <remarks/>
        public MsgHeaderServiceName ServiceName {
            get {
                return this.serviceNameField;
            }
            set {
                this.serviceNameField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ServiceNameSpecified {
            get {
                return this.serviceNameFieldSpecified;
            }
            set {
                this.serviceNameFieldSpecified = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum MsgHeaderServiceName {
        
        /// <remarks/>
        ApprovalRequestsService,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class ApprovalRequest {
        
        private long codeField;
        
        private bool codeFieldSpecified;
        
        private string objectTypeField;
        
        private string isDraftField;
        
        private long objectEntryField;
        
        private bool objectEntryFieldSpecified;
        
        private ApprovalRequestStatus statusField;
        
        private bool statusFieldSpecified;
        
        private string remarksField;
        
        private long currentStageField;
        
        private bool currentStageFieldSpecified;
        
        private long originatorIDField;
        
        private bool originatorIDFieldSpecified;
        
        private ApprovalRequestApprovalRequestLine[] approvalRequestLinesField;
        
        private ApprovalRequestApprovalRequestDecision[] approvalRequestDecisionsField;
        
        /// <remarks/>
        public long Code {
            get {
                return this.codeField;
            }
            set {
                this.codeField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool CodeSpecified {
            get {
                return this.codeFieldSpecified;
            }
            set {
                this.codeFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string ObjectType {
            get {
                return this.objectTypeField;
            }
            set {
                this.objectTypeField = value;
            }
        }
        
        /// <remarks/>
        public string IsDraft {
            get {
                return this.isDraftField;
            }
            set {
                this.isDraftField = value;
            }
        }
        
        /// <remarks/>
        public long ObjectEntry {
            get {
                return this.objectEntryField;
            }
            set {
                this.objectEntryField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ObjectEntrySpecified {
            get {
                return this.objectEntryFieldSpecified;
            }
            set {
                this.objectEntryFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public ApprovalRequestStatus Status {
            get {
                return this.statusField;
            }
            set {
                this.statusField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StatusSpecified {
            get {
                return this.statusFieldSpecified;
            }
            set {
                this.statusFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string Remarks {
            get {
                return this.remarksField;
            }
            set {
                this.remarksField = value;
            }
        }
        
        /// <remarks/>
        public long CurrentStage {
            get {
                return this.currentStageField;
            }
            set {
                this.currentStageField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool CurrentStageSpecified {
            get {
                return this.currentStageFieldSpecified;
            }
            set {
                this.currentStageFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long OriginatorID {
            get {
                return this.originatorIDField;
            }
            set {
                this.originatorIDField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool OriginatorIDSpecified {
            get {
                return this.originatorIDFieldSpecified;
            }
            set {
                this.originatorIDFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlArrayItemAttribute("ApprovalRequestLine", IsNullable=false)]
        public ApprovalRequestApprovalRequestLine[] ApprovalRequestLines {
            get {
                return this.approvalRequestLinesField;
            }
            set {
                this.approvalRequestLinesField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlArrayItemAttribute("ApprovalRequestDecision", IsNullable=false)]
        public ApprovalRequestApprovalRequestDecision[] ApprovalRequestDecisions {
            get {
                return this.approvalRequestDecisionsField;
            }
            set {
                this.approvalRequestDecisionsField = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum ApprovalRequestStatus {
        
        /// <remarks/>
        arsPending,
        
        /// <remarks/>
        arsApproved,
        
        /// <remarks/>
        arsNotApproved,
        
        /// <remarks/>
        arsGenerated,
        
        /// <remarks/>
        arsGeneratedByAuthorizer,
        
        /// <remarks/>
        arsCancelled,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class ApprovalRequestApprovalRequestLine {
        
        private long stageCodeField;
        
        private bool stageCodeFieldSpecified;
        
        private long userIDField;
        
        private bool userIDFieldSpecified;
        
        private ApprovalRequestApprovalRequestLineStatus statusField;
        
        private bool statusFieldSpecified;
        
        private string remarksField;
        
        /// <remarks/>
        public long StageCode {
            get {
                return this.stageCodeField;
            }
            set {
                this.stageCodeField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StageCodeSpecified {
            get {
                return this.stageCodeFieldSpecified;
            }
            set {
                this.stageCodeFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long UserID {
            get {
                return this.userIDField;
            }
            set {
                this.userIDField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool UserIDSpecified {
            get {
                return this.userIDFieldSpecified;
            }
            set {
                this.userIDFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public ApprovalRequestApprovalRequestLineStatus Status {
            get {
                return this.statusField;
            }
            set {
                this.statusField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StatusSpecified {
            get {
                return this.statusFieldSpecified;
            }
            set {
                this.statusFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string Remarks {
            get {
                return this.remarksField;
            }
            set {
                this.remarksField = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum ApprovalRequestApprovalRequestLineStatus {
        
        /// <remarks/>
        ardPending,
        
        /// <remarks/>
        ardApproved,
        
        /// <remarks/>
        ardNotApproved,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class ApprovalRequestApprovalRequestDecision {
        
        private string approverUserNameField;
        
        private string approverPasswordField;
        
        private ApprovalRequestApprovalRequestDecisionStatus statusField;
        
        private bool statusFieldSpecified;
        
        private string remarksField;
        
        /// <remarks/>
        public string ApproverUserName {
            get {
                return this.approverUserNameField;
            }
            set {
                this.approverUserNameField = value;
            }
        }
        
        /// <remarks/>
        public string ApproverPassword {
            get {
                return this.approverPasswordField;
            }
            set {
                this.approverPasswordField = value;
            }
        }
        
        /// <remarks/>
        public ApprovalRequestApprovalRequestDecisionStatus Status {
            get {
                return this.statusField;
            }
            set {
                this.statusField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StatusSpecified {
            get {
                return this.statusFieldSpecified;
            }
            set {
                this.statusFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string Remarks {
            get {
                return this.remarksField;
            }
            set {
                this.remarksField = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum ApprovalRequestApprovalRequestDecisionStatus {
        
        /// <remarks/>
        ardPending,
        
        /// <remarks/>
        ardApproved,
        
        /// <remarks/>
        ardNotApproved,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class ApprovalRequestParams {
        
        private long codeField;
        
        private bool codeFieldSpecified;
        
        private string remarksField;
        
        private ApprovalRequestParamsStatus statusField;
        
        private bool statusFieldSpecified;
        
        /// <remarks/>
        public long Code {
            get {
                return this.codeField;
            }
            set {
                this.codeField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool CodeSpecified {
            get {
                return this.codeFieldSpecified;
            }
            set {
                this.codeFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string Remarks {
            get {
                return this.remarksField;
            }
            set {
                this.remarksField = value;
            }
        }
        
        /// <remarks/>
        public ApprovalRequestParamsStatus Status {
            get {
                return this.statusField;
            }
            set {
                this.statusField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StatusSpecified {
            get {
                return this.statusFieldSpecified;
            }
            set {
                this.statusFieldSpecified = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum ApprovalRequestParamsStatus {
        
        /// <remarks/>
        arsPending,
        
        /// <remarks/>
        arsApproved,
        
        /// <remarks/>
        arsNotApproved,
        
        /// <remarks/>
        arsGenerated,
        
        /// <remarks/>
        arsGeneratedByAuthorizer,
        
        /// <remarks/>
        arsCancelled,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class ApprovalRequestsParamsApprovalRequestParams {
        
        private long codeField;
        
        private bool codeFieldSpecified;
        
        private string remarksField;
        
        private ApprovalRequestsParamsApprovalRequestParamsStatus statusField;
        
        private bool statusFieldSpecified;
        
        /// <remarks/>
        public long Code {
            get {
                return this.codeField;
            }
            set {
                this.codeField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool CodeSpecified {
            get {
                return this.codeFieldSpecified;
            }
            set {
                this.codeFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string Remarks {
            get {
                return this.remarksField;
            }
            set {
                this.remarksField = value;
            }
        }
        
        /// <remarks/>
        public ApprovalRequestsParamsApprovalRequestParamsStatus Status {
            get {
                return this.statusField;
            }
            set {
                this.statusField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StatusSpecified {
            get {
                return this.statusFieldSpecified;
            }
            set {
                this.statusFieldSpecified = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.0.30319.34230")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum ApprovalRequestsParamsApprovalRequestParamsStatus {
        
        /// <remarks/>
        arsPending,
        
        /// <remarks/>
        arsApproved,
        
        /// <remarks/>
        arsNotApproved,
        
        /// <remarks/>
        arsGenerated,
        
        /// <remarks/>
        arsGeneratedByAuthorizer,
        
        /// <remarks/>
        arsCancelled,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    public delegate void UpdateRequestCompletedEventHandler(object sender, System.ComponentModel.AsyncCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    public delegate void GetApprovalRequestCompletedEventHandler(object sender, GetApprovalRequestCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class GetApprovalRequestCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal GetApprovalRequestCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public ApprovalRequest Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((ApprovalRequest)(this.results[0]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    public delegate void GetApprovalRequestListCompletedEventHandler(object sender, GetApprovalRequestListCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class GetApprovalRequestListCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal GetApprovalRequestListCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public ApprovalRequestsParamsApprovalRequestParams[] Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((ApprovalRequestsParamsApprovalRequestParams[])(this.results[0]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    public delegate void GetOpenApprovalRequestListCompletedEventHandler(object sender, GetOpenApprovalRequestListCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class GetOpenApprovalRequestListCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal GetOpenApprovalRequestListCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public ApprovalRequestsParamsApprovalRequestParams[] Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((ApprovalRequestsParamsApprovalRequestParams[])(this.results[0]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    public delegate void GetAllApprovalRequestsListCompletedEventHandler(object sender, GetAllApprovalRequestsListCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.0.30319.33440")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class GetAllApprovalRequestsListCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal GetAllApprovalRequestsListCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public ApprovalRequestsParamsApprovalRequestParams[] Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((ApprovalRequestsParamsApprovalRequestParams[])(this.results[0]));
            }
        }
    }
}

#pragma warning restore 1591